/*
Copyright (C) 1995 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

Program bacuy_eq: Computing Phase Diagram of Ba-Cu-Y

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*/


#include <fstream.h>

extern double T;
extern double xBa, xCu, xY;

extern ofstream of, lf;
extern ifstream df;
extern int print;
extern int interactive;
extern int command_line;
extern double hBaY;
extern double sBaY;
extern long grid;

double Dmixg1(double T, double XCU, double XY);
double Dmixg2(double T, double XCU, double XY);
double Dmixg3(double T, double XCU, double XY);
void coeff(double T);
double gCus(double T);
double gCul(double T, double xCu = 0., double xY = 0.);
double gYs(double T);
double gYl(double T, double xCu = 0., double xY = 0.);
double gBas(double T);
double gBal(double T, double xCu = 0., double xY = 0.);
double gCu6Y(double T);
double gCu4Y(double T);
double gCu7Y2(double T);
double gCu2Y(double T);
double gCuY(double T);
double gBaCu(double T);
double gBaCu13(double T);
void xtoz(double x1, double x2, double& z1, double &z2);
void ztox(double& x1, double& x2, double z1, double z2);
void dxdz(double& dx1dz1, double& dx1dz2,
          double& dx2dz1, double& dx2dz2,
          double z1, double z2);
int lp_estimates();

using namespace::std;


