/*
Copyright (C) 1995 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

Program bacuy_eq: Computing Phase Diagram of Ba-Cu-Y

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*/

#include <string.h>
#include <iostream.h>

extern "C"
{
#include "donlp.h"

int setup_(void)
{
  return 0;
}

int ef_(double *x, double *fx)
{
  ++o6cnt_1.cf;
//  *fx = -(x[0] + x[1]);
  *fx = -(2.*x[0] + 4*x[1]);
//  *fx = -(2.*x[0] + 4*x[1] - 0.1*x[0]*x[1]);
  cout << "f " << x[0] << "  " << x[1] << "  " << *fx << endl;
  return 0;
}

int egradf_(double *x, double *gradf)
{
  ++o6cnt_1.cgf;
//  gradf[0] = -1.;
//  gradf[1] = -1.;
  gradf[0] = -2.;
  gradf[1] = -4.;
//  gradf[0] = -2.+0.1*x[0];
//  gradf[1] = -4.+0.1*x[1];
  return 0;
}

int eh_(long *i, double *x, double *hxi)
{
//  cout << "eh " << endl;
  ++o6cnt_1.cres[*i - 1];
  cout << "something wrong - eh_" << endl;
  return 0;
}

int egradh_(long *i, double *x, double *gradhi)
{
//  cout << "egradh " << endl;
  ++o6cnt_1.cgres[*i - 1];
  cout << "something wrong - egradh_" << endl;
  return 0;
}

int eg_(long *i, double *x, double *gxi)
{
//  cout << "eg " << *i << endl;
  ++o6cnt_1.cres[*i + o6dim_1.nh - 1];
  switch (*i)
  {
    case 1:
//      *gxi = x[0] - x[1] - 1.;
      *gxi = 1700. - 3.*x[0] - 4.*x[1];
      break;
    case 2:
//      *gxi = 2. - x[1];
      *gxi = 1600. - 2.*x[0] - 5.*x[1];
      break;
    case 3:
//      *gxi = x[0];
      *gxi = x[0] - 25;
      break;
    case 4:
//      *gxi = x[1];
      *gxi = x[1] - 45;
      break;
    default:
     cout << "something wrong - eg_" << endl;
  }
  return 0;
}

int egradg_(long *i, double *x, double *gradgi)
{
//  cout << "egradg " << *i << endl;
  ++o6cnt_1.cgres[*i + o6dim_1.nh - 1];
  switch (*i)
  {
    case 1:
//      gradgi[0] = 1.;
//      gradgi[1] = -1.;
      gradgi[0] = -3.;
      gradgi[1] = -4.;
      break;
    case 2:
//      gradgi[0] = 0.;
//      gradgi[1] = -1.;
      gradgi[0] = -2.;
      gradgi[1] = -5.;
      break;
    case 3:
      gradgi[0] = 1.;
      gradgi[1] = 0.;
      break;
    case 4:
      gradgi[0] = 0.;
      gradgi[1] = 1.;
      break;
    default:
     cout << "something wrong - egradg_" << endl;
  }
  return 0;
}

int setup0_(void)
{
  o6stpa_1.analyt = 1;
  o6der_1.epsdif = 0.;
  o6io_1.prou = 10;
  o6io_1.meu = 20;
  o6stpa_1.silent = 0;
  o6dim_1.n = 2;
  o6dim_1.nh = 0;
  o6dim_1.ng = 4;
  int i, j;
  strcpy(o6id_1.name, "linear_prog");
  o6par_1.del0 = .1;
  o6par_1.tau0 = .5;
  o6par_1.tau = 1.;
  o6xdat_1.x[0] = 3.;
  o6xdat_1.x[1] = 1.;
//  for (i = 0; i < 31; i++)
  for (i = 0; i < o6dim_1.nh + o6dim_1.ng; i++)
  {
    o6gri_1.gunit[3*i+0] =  -1;
    o6gri_1.gunit[3*i+1] =  0;
    o6gri_1.gunit[3*i+2] =  0;
  }
  return 0;
}

}

int main()
{
	return MAIN__();
}	
